package com.partisiablockchain.language;

/*
 * Copyright (C) 2022 - 2023 Partisia Blockchain Foundation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import com.secata.tools.coverage.ExceptionConverter;
import java.nio.file.Files;
import java.nio.file.Path;
import org.apache.maven.execution.MavenSession;
import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugins.annotations.Component;
import org.apache.maven.plugins.annotations.LifecyclePhase;
import org.apache.maven.plugins.annotations.Mojo;
import org.apache.maven.plugins.annotations.Parameter;
import org.apache.maven.project.MavenProject;
import org.apache.maven.project.MavenProjectHelper;

/**
 * Mojo that deploys an ABI that has been generated by the {@link AutoSysContractProcessor}. The
 * code assumes the ABI has been generated and will fail with an exception otherwise.
 */
@Mojo(name = "deploy-abi", defaultPhase = LifecyclePhase.COMPILE)
public final class DeployAbi extends AbstractMojo {

  @Parameter(defaultValue = "${session}", required = true, readonly = true)
  MavenSession session;

  @Component MavenProjectHelper mavenProjectHelper;

  @Override
  public void execute() throws MojoExecutionException {
    MavenProject project = session.getCurrentProject();

    Path mainTxt = targetFile(project, "main");
    if (!Files.exists(mainTxt)) {
      throw new MojoExecutionException("No 'main' file found.");
    }

    String contractName =
        ExceptionConverter.call(() -> Files.readString(mainTxt).trim().replaceAll("Invoker$", ""));

    getLog().info("Adding ABI file: " + contractName);
    Path outputPath = targetFile(project, "%s.abi".formatted(contractName));

    mavenProjectHelper.attachArtifact(project, "abi", "abi", outputPath.toFile());
  }

  static Path projectFile(MavenProject project) {
    Path projectFolder = project.getBasedir().toPath();
    return projectFolder.resolve("pom.xml");
  }

  static Path targetFile(MavenProject project, String file) {
    return getBuildDir(project).resolve("classes").resolve(file);
  }

  private static Path getBuildDir(MavenProject project) {
    String buildDir = project.getBuild().getDirectory();
    Path projectFolder = project.getBasedir().toPath();
    return projectFolder.resolve(buildDir);
  }
}
